ks = 10000;
mc = 1000/4;
kw  = 100000;
b = 5000;
mw = 1;

% our state vector is [X_disp X_velocity Y_disp Y_velocity]
A = [0, 1, 0, 0;
    (-ks/mw-kw/mw),(-b/mw),ks/mw,b/mw;
    0,0,0,1;
    ks/mc,b/mc,-ks/mc,-b/mc]; %A describes the cars internal dynamics - note this contains all the internal forces affecting the system, leaving only the force from the road

B = [0;
    kw/mw;
    0;
    0]; %B desctribes how the inputs (here the displacement of the road surface is our input) links to the internal state

C = [0,0,1,0]; %C describes how the state links to the output. lets start with the displacement of the car, Y

D = 0; %descibes how the output and input are linked external to the system, generally they are not in which case D = 0 or [];


sysRC = ss(A,B,C,D);
figure(1)
step(sysRC)
stepinfo(sysRC)

%now lets look at the displacement of the spring, which is Y-X, and see
%what the max deflection is for a step of 1m

C = [0,0,1,0;
    1,0,0,0;
    1,0,-1,0]; %IC wheel-IC car = displacement of the spring -> suspension compression
sysDisp =  ss(A,B,C,D);

figure(2);
step(sysDisp);
stepinf = stepinfo(sysDisp);

%%peak is 0.0649 for a step of 1m. the max displacement is 0.1m,
% and so the maximum step input which would not bottom out the suspension is
% 0.1/0.0649 = ~1.5m . This is pretty extreme, and is because the wheel spring
%constant is way too low. if kw = 500,000, which is significantly more
%realistic, then we find the maxStep = 13cm, much closer to reality. always
maxStep = 1*(0.1/stepinf(3).Peak)

